#ifndef MACCATEGORYELEMENTWIDGET_H
#define MACCATEGORYELEMENTWIDGET_H

#include "gmc-miscellaneousse_global.h"

#include <elementwidget.h>

namespace Ui
{
class MacCategoryElementWidget;
}

class IntIntervalModel;
class IntSortFilterProxyModel;

class GMCMISCELLANEOUSSESHARED_EXPORT MacCategoryElementWidget : public ViewEditElementWidget
{

    Q_OBJECT

public:

    MacCategoryElementWidget( Element * /*rootElement*/
                            , Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & )
                            , QWidget * /*parent*/ = 0 );
    virtual ~MacCategoryElementWidget();

    virtual void beforeCreation();
    virtual ElementData * exportElementData() const;
    virtual void afterSuccessfulRead( Element * /*testElement*/, ElementData * /*elementData*/ );


    virtual QString caption() const;

protected:

    virtual void reset();
    virtual bool isContentValid() const;
    virtual void blockEditWidget( bool /*blocked*/ );

protected slots:

    void setCategoryLabel( int /*index*/ );

private:

    Ui::MacCategoryElementWidget *_ui;

    Element *_rootElement;
    IntIntervalModel *_intervalModel;
    IntSortFilterProxyModel *_intSortFilterProxyModel;

};

#endif // MACCATEGORYELEMENTWIDGET_H
