#ifndef MACILEVELELEMENTWIDGET_H
#define MACILEVELELEMENTWIDGET_H

#include "gmc-miscellaneousse_global.h"

#include <elementwidget.h>

namespace Ui
{
class MacIlevelElementWidget;
}

class IntIntervalModel;
class IntSortFilterProxyModel;

class GMCMISCELLANEOUSSESHARED_EXPORT MacILevelElementWidget : public ViewEditElementWidget
{

    Q_OBJECT

public:

    MacILevelElementWidget( Element * /*rootElement*/
                          , Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & )
                          , QWidget * /*parent*/ = 0 );
    virtual ~MacILevelElementWidget();

    virtual void afterSuccessfulRead( Element * /*testElement*/, ElementData * /*elementData*/ );
    virtual ElementData * exportElementData() const;

    virtual QString caption() const;

protected:

    virtual void reset();
    virtual bool isContentValid() const;
    virtual void blockEditWidget( bool /*blocked*/ );

private:

    Ui::MacIlevelElementWidget *_ui;

    Element *_rootElement;
    IntIntervalModel *_intervalModel;
    IntSortFilterProxyModel *_intSortFilterProxyModel;

};

#endif // MACILEVELELEMENTWIDGET_H
