#ifndef MACLEVELELEMENTWIDGET_H
#define MACLEVELELEMENTWIDGET_H

#include "gmc-miscellaneousse_global.h"

#include <elementwidget.h>

namespace Ui
{
class MacLevelElementWidget;
}

class IntIntervalModel;
class IntSortFilterProxyModel;

class GMCMISCELLANEOUSSESHARED_EXPORT MacLevelElementWidget : public ViewEditElementWidget
{

    Q_OBJECT

public:

    MacLevelElementWidget( Element * /*rootElement*/
                         , Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & )
                         , QWidget * /*parent*/ = 0 );
    virtual ~MacLevelElementWidget();

    virtual void beforeCreation();
    virtual ElementData * exportElementData() const;
    virtual void afterSuccessfulRead( Element * /*testElement*/, ElementData * /*elementData*/ );

    virtual QString caption() const;

protected:

    virtual void reset();
    virtual bool isContentValid() const;
    virtual void blockEditWidget( bool /*blocked*/ );

private:

    Ui::MacLevelElementWidget *_ui;
    Element *_rootElement;
    IntIntervalModel *_intervalModel;
    IntSortFilterProxyModel *_intSortFilterProxyModel;

};

#endif // MACLEVELELEMENTWIDGET_H
