#ifndef MISCELLANEOUSELEMENT_H
#define MISCELLANEOUSELEMENT_H

#include "gmc-miscellaneousse_global.h"

#include <element.h>

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT MacCategoriesElement : public ContainerElement
{

    Q_OBJECT

public:

    enum ElementColumnsType { DigitColumn = ElementRootTreeNode::_CountColumns
                            , SynonymColumn
                            , _CountColumns };

    MacCategoriesElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~MacCategoriesElement();

    virtual int columnCount() const;
    virtual QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT MacLevelsElement : public ContainerElement
{

    Q_OBJECT

public:

    enum ElementColumnsType { LevelColumn = ElementRootTreeNode::_CountColumns
                            , SynonymColumn
                            , _CountColumns };

    MacLevelsElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~MacLevelsElement();

    virtual int columnCount() const;
    virtual QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT MacILevelsElement : public MacLevelsElement
{

    Q_OBJECT

public:

    MacILevelsElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~MacILevelsElement();

//TODO REMOVE THIS
    virtual qulonglong availableOperations() const;
//TODO REMOVE THIS
    virtual void performOperation( OperationType /*operation*/
                                 , ElementData * /*elementData*/ = 0
                                 , int /*depth*/ = 0 );

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT MacCategoryElement : public OrdinaryElement
{

    Q_OBJECT

public:

    MacCategoryElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~MacCategoryElement();

    virtual QVariant data( int /*column*/, int /*role*/ = Qt::DisplayRole ) const;

    virtual QString caption() const;
};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT MacLevelElement : public OrdinaryElement
{

    Q_OBJECT

public:

    MacLevelElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~MacLevelElement();

    virtual qulonglong availableOperations() const;

    virtual QVariant data( int /*column*/, int /*role*/ = Qt::DisplayRole ) const;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT MacILevelElement : public MacLevelElement
{

    Q_OBJECT

public:

    MacILevelElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~MacILevelElement();

//TODO REMOVE THIS
    virtual qulonglong availableOperations() const;
//TODO REMOVE THIS
    virtual void performOperation( OperationType /*operation*/
                                 , ElementData * /*elementData*/ = 0
                                 , int /*depth*/ = 0 );

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT DefaultAuditElement : public OrdinaryElement
{

    Q_OBJECT

public:

    DefaultAuditElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~DefaultAuditElement();

    virtual qulonglong availableOperations() const;
    virtual void performOperation( OperationType /*operation*/
                                 , ElementData * /*elementData*/ = 0
                                 , int /*depth*/ = 0 );
};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT AuditObjectsElement : public ContainerElement
{

    Q_OBJECT

public:

    enum ElementColumnsType { NameColumn = ElementRootTreeNode::_CountColumns
                            , SuccessColumn
                            , FailColumn
                            , _CountColumns };

    AuditObjectsElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~AuditObjectsElement();

    virtual qulonglong availableOperations() const;
    virtual void performOperation( OperationType /*operation*/
                                 , ElementData * /*elementData*/ = 0
                                 , int /*depth*/ = 0 );

    virtual int columnCount() const;
    virtual QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const;
};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT AuditUsersElement : public AuditObjectsElement
{

    Q_OBJECT

public:

    AuditUsersElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~AuditUsersElement();

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT AuditGroupsElement : public AuditObjectsElement
{

    Q_OBJECT

public:

    AuditGroupsElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~AuditGroupsElement();

};

//******************************************************************************

//public:
class GMCMISCELLANEOUSSESHARED_EXPORT AuditObjectElement : public OrdinaryElement
{

    Q_OBJECT

public:

    AuditObjectElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~AuditObjectElement();

    virtual qulonglong availableOperations() const;
    virtual void performOperation( OperationType /*operation*/
                                 , ElementData * /*elementData*/ = 0
                                 , int /*depth*/ = 0 );
};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT CapabilitiesUsersElement : public ContainerElement
{

    Q_OBJECT

public:

    enum ElementColumnsType { NameColumn = ElementRootTreeNode::_CountColumns
                            , LinuxCapabilitiesColumn
                            , ParsecCapabilitiesColumn
                            , _CountColumns };

    CapabilitiesUsersElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~CapabilitiesUsersElement();

    virtual qulonglong availableOperations() const;
    virtual void performOperation( OperationType /*operation*/
                                 , ElementData * /*elementData*/ = 0
                                 , int /*depth*/ = 0 );

    virtual int columnCount() const;
    virtual QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const;
};

//******************************************************************************

//public:
class GMCMISCELLANEOUSSESHARED_EXPORT CapabilitiesObjectElement : public OrdinaryElement
{

    Q_OBJECT

public:

    CapabilitiesObjectElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~CapabilitiesObjectElement();

    virtual qulonglong availableOperations() const;
    virtual void performOperation( OperationType /*operation*/
                                 , ElementData * /*elementData*/ = 0
                                 , int /*depth*/ = 0);

    virtual QVariant data( int /*column*/, int /*role*/ = Qt::DisplayRole ) const;
};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT DeviceDevicesElement : public ContainerElement
{

    Q_OBJECT

public:

    enum ElementColumnsType { NameColumn = ElementRootTreeNode::_CountColumns
                            , UserColumn
                            , GroupColumn
                            , ModeColumn
                            , EnabledColumn
                            , _CountColumns };

    DeviceDevicesElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~DeviceDevicesElement();

    virtual int columnCount() const;
    virtual QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT DeviceRulesElement : public ContainerElement
{

    Q_OBJECT

public:

    enum ElementColumnsType { NameColumn = ElementRootTreeNode::_CountColumns
                            , EnabledColumn
                            , _CountColumns };

    DeviceRulesElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~DeviceRulesElement();

    virtual int columnCount() const;
    virtual QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT DeviceDeviceElement : public OrdinaryElement
{

    Q_OBJECT

public:

    DeviceDeviceElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~DeviceDeviceElement();

    virtual QVariant data( int /*column*/, int /*role*/ = Qt::DisplayRole ) const;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT DeviceRuleElement : public OrdinaryElement
{

    Q_OBJECT

public:

    DeviceRuleElement( Module & /*module*/
                     , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~DeviceRuleElement();

    virtual QVariant data( int /*column*/, int /*role*/ = Qt::DisplayRole ) const;

};

#endif // MISCELLANEOUSELEMENT_H
