#ifndef MISCELLANEOUSMODELSE_H
#define MISCELLANEOUSMODELSE_H

#include "gmc-miscellaneousse_global.h"

#include <elementmodel.h>

#include <miscellaneousmodel.h>

class Module;

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT TwoCheckTreeNodeModel : public OneCheckTreeNodeModel
{

    Q_OBJECT

public:

    TwoCheckTreeNodeModel( QObject * /*parent*/ = 0 );
    TwoCheckTreeNodeModel( TreeNode * /*rootNode*/, QObject * /*parent*/ = 0 );
    virtual ~TwoCheckTreeNodeModel();

    virtual int columnCount( const QModelIndex &  = QModelIndex() ) const;
    virtual QVariant data( const QModelIndex & /*index*/
                         , int /*role*/ = Qt::DisplayRole ) const;

    virtual bool setData( const QModelIndex & /*index*/
                        , const QVariant & /*value*/
                        , int /*role*/ = Qt::EditRole );

    qulonglong secondValue() const;
    void setSecondValue( const qulonglong /*secondValue*/ );

    virtual void setValues( const qulonglong /*firstValue*/
                          , const qulonglong /*secondValue*/ );

protected:

    qulonglong _secondValue;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT MacCategoriesTwoCheckTreeNodeModel : public TwoCheckTreeNodeModel
{

    Q_OBJECT

public:

    MacCategoriesTwoCheckTreeNodeModel( QObject * /*parent*/ = 0 );
    MacCategoriesTwoCheckTreeNodeModel( TreeNode * /*rootNode*/, QObject * /*parent*/ = 0 );
    virtual ~MacCategoriesTwoCheckTreeNodeModel();

    virtual bool setData( const QModelIndex & /*index*/
                        , const QVariant & /*value*/
                        , int /*role*/ = Qt::EditRole );

    virtual QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const;

    virtual Qt::ItemFlags flags( const QModelIndex & ) const;

    virtual void setValues( const qulonglong /*firstValue*/
                          , const qulonglong /*secondValue*/ );

private:

    void setFirstValue( const qulonglong /*secondValue*/ );
    void setSecondValue( const qulonglong /*secondValue*/ );

protected:

    Module *_dummyModule;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT MacLevelProxyModel : public QSortFilterProxyModel
{

    Q_OBJECT

public:

    MacLevelProxyModel( bool /*isMax*/, QObject * /*parent*/ = 0 );
    virtual ~MacLevelProxyModel();

    virtual bool filterAcceptsRow( int /*srcRow*/, const QModelIndex & /*srcParentIndex*/ ) const;

    int threshold() const;
    void setThreshold( int threshold );
    void resetThreshold();

protected:

    bool _isMax;
    int _threshold;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT AuditTwoCheckTreeNodeModel : public TwoCheckTreeNodeModel
{

    Q_OBJECT

public:

    AuditTwoCheckTreeNodeModel( QObject * /*parent*/ = 0 );
    AuditTwoCheckTreeNodeModel( TreeNode * /*rootNode*/, QObject * /*parent*/ = 0 );
    virtual ~AuditTwoCheckTreeNodeModel();

    virtual QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const;

};

//******************************************************************************

class LocalCategoriesTreeNodeSortFilterProxyModel
: public TreeNodeSortFilterProxyModel
{

    Q_OBJECT

public:

    LocalCategoriesTreeNodeSortFilterProxyModel( QObject * /*parent*/ = 0 );
    virtual ~LocalCategoriesTreeNodeSortFilterProxyModel();

};

//******************************************************************************

class IntIntervalModel : public QAbstractListModel
{

    Q_OBJECT

public:

    IntIntervalModel( int /*min*/, int /*size*/, QObject * /*parent*/ = 0 );
    virtual ~IntIntervalModel();

    virtual int rowCount( const QModelIndex & /*parentIndex*/ = QModelIndex() ) const;
    virtual QVariant data( const QModelIndex & /*index*/, int /*role*/ = Qt::DisplayRole) const;

protected:

    int _min;
    int _size;

};

//******************************************************************************

class IntSortFilterProxyModel : public QSortFilterProxyModel
{

    Q_OBJECT

public:

    IntSortFilterProxyModel( QObject * /*parent*/ );
    virtual ~IntSortFilterProxyModel();

    const QSet<int> &filteredValues() const;
    void setFilteredValues( const QSet<int> & /*filteredValues*/ );
    void clear();

protected:

    virtual bool filterAcceptsRow( int /*srcRow*/
                                 , const QModelIndex & /*srcParentIndex*/ ) const;

protected:

    QSet< int > _filteredValues;

};

//******************************************************************************

#endif
