#ifndef OBJECTAUDITELEMENTWIDGET_H
#define OBJECTAUDITELEMENTWIDGET_H

#include "gmc-miscellaneousse_global.h"

#include <elementwidget.h>

class QSortFilterProxyModel;

class AuditComponentRootTreeNode;
class AuditTwoCheckTreeNodeModel;

namespace Ui
{
class ObjectAuditElementWidget;
}

class GMCMISCELLANEOUSSESHARED_EXPORT ObjectAuditElementWidget : public ViewEditElementWidget
{
    Q_OBJECT

public:

    ObjectAuditElementWidget( Element * /*defaultAuditElement*/
                            , Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & )
                            , QWidget * /*parent*/ = 0 );
    virtual ~ObjectAuditElementWidget();

    virtual void afterSuccessfulRead( Element * /*testElement*/, ElementData * /*elementData*/ );
    virtual ElementData *exportElementData() const;

    virtual QString caption() const;

protected:

    void loadSettings();
    void saveSettings() const;

    virtual void reset();
    virtual void blockEditWidget( bool /*blocked*/ );

    virtual QString auditToString( qulonglong ) const = 0;

protected slots:

    void auditDefaultResest( int state );
    void auditChanged();

protected:

    Ui::ObjectAuditElementWidget *_ui;

    Element *_defaultAuditElement;

    AuditTwoCheckTreeNodeModel *_auditTreeNodeModel;
    QSortFilterProxyModel *_sortFilterProxyModel;

};

#endif // OBJECTAUDITELEMENTWIDGET_H
