#ifndef RULEELEMENTWIDGET_H
#define RULEELEMENTWIDGET_H

#include "gmc-miscellaneousse_global.h"

#include <elementwidget.h>

#include "ruledeviceserviceexpressions.h"

class QValidator;

namespace Ui
{
class RuleElementWidget;
}

class GMCMISCELLANEOUSSESHARED_EXPORT RuleElementWidget
: public ViewEditElementWidget
, public RuleDeviceExpressionsServiceClass
{

    Q_OBJECT

public:

    RuleElementWidget( Module & /*module*/
                     , bool ( * /*isEditable*/ )( const Module & ), QWidget * /*parent*/ = 0 );
    virtual ~RuleElementWidget();

    void init();

    virtual void beforeCreation();
    virtual ElementData * exportElementData() const;
    virtual void afterSuccessfulRead( Element * /*testElement*/, ElementData * /*elementData*/ );

    virtual QString caption() const;

protected:

    virtual void reset();
    virtual bool isContentValid() const;
    virtual void blockEditWidget( bool /*blocked*/ );


protected slots:

    void importRecordData();
    void descriptionChanged();

protected:

    Ui::RuleElementWidget *_ui;
    int _descriptionMaxSize;
    QValidator *_nameValidator;

};

#endif // RULEELEMENTWIDGET_H
